//+------------------------------------------------------------------+
//|                     Henderson's filter_multi color_mtf_Sdvig.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"
#property copyright "mladen"
#property description "C    Y"
#property description "*      * 10.04.16"
#property description " "
#property description "  TF   "
#property description "*   Joker62   * 10.04.16 "
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DeepSkyBlue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
enum ENUM_YN
 {
  enum_n = 0, // 
  enum_y = 1  // 
 };

enum ENUM_TF
 {
  eM0  = PERIOD_CURRENT, // Current time frame
  eM1  = PERIOD_M1,      // M1
  eM5  = PERIOD_M5,      // M5
  eM15 = PERIOD_M15,     // M15
  eM30 = PERIOD_M30,     // M30
  eH1  = PERIOD_H1,      // H1
  eH4  = PERIOD_H4,      // H4
  eD1  = PERIOD_D1,      // D1
  eW1  = PERIOD_W1,      // W1
  eMN1 = PERIOD_MN1      // MN
 };
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
extern ENUM_TF            iTimeFrame  = 0;
extern ENUM_APPLIED_PRICE Price       = PRICE_CLOSE;
extern int                FilterSize  = 13;
extern ENUM_YN            MultiColor  = true;
extern ENUM_YN            Interpolate = true;
extern double             sdvig       = 0.0025;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       double buffer1[];
       double buffer2[];
       double buffer3[];
       double trend[];
       double weights[];
       
       int half;
       int timeFrame;
       int iTfTable[] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
       
       string TimeFrame;
       string indicatorFileName;
       string sTfTable[] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN"};
       
       bool calculateValue;
       bool returnBars;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
 {
  IndicatorBuffers(4);
  
  SetIndexBuffer(0, buffer1);
  SetIndexBuffer(1, buffer2);
  
  if (MultiColor)
   SetIndexStyle(1, DRAW_LINE);
  else
   SetIndexStyle(1, DRAW_NONE);
  
  //-----
  SetIndexBuffer(2, buffer3);
  
  if (MultiColor)
   SetIndexStyle(2, DRAW_LINE);
  else
   SetIndexStyle(2, DRAW_NONE);
  
  SetIndexBuffer(3,trend);
  
  FilterSize = MathMax(FilterSize, 3);
  
  if (MathMod(FilterSize, 2) == 0)
   FilterSize++;
  
  half = MathFloor(FilterSize / 2.0);
  
  TimeFrame         = (string)iTimeFrame;
  indicatorFileName = WindowExpertName();
  timeFrame         = stringToTimeFrame(TimeFrame);
  returnBars        = (TimeFrame == "returnBars");
  
  if (returnBars)
   return(0);
  
  //-----
  calculateValue = (TimeFrame == "calculateValue");
  
  if (calculateValue || timeFrame == Period())
   {
    ArrayResize(weights, FilterSize);
    
    double m       = half;
    double divisor = 8.0 * (m + 2.0) *((m + 2.0) * (m + 2.0) - 1.0) * (4.0 * (m + 2.0) * (m + 2) - 1.0) * (4.0 * (m + 2.0) * (m + 2.0) - 9.0) * (4.0 * (m + 2.0) * (m + 2.0) - 25.0);
    
    for (int j = -half; j <= half; j++)
     weights[j + half] = 315.0 * ((m + 1.0) * (m + 1.0) - (j * j)) * ((m + 2.0) * (m + 2.0) - (j * j)) * ((m + 3.0) * (m + 3.0) - (j * j)) * (3.0 * (m + 2.0) * (m + 2.0) - 11.0 * (j * j) - 16.0) / divisor;
   } // exit if (calculateValue || timeFrame == Period())
  
  if (calculateValue)
   return(0);
  
  //-------------------------
  return(0);
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
 {
  //-----
  
  //-------------------------
  return(0);
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
 {
  int limit, counted_bars = IndicatorCounted();
  int size = ArraySize(weights);
  
  if (counted_bars < 0)
   return(-1);
  
  if (counted_bars > 0)
   counted_bars--;
  
  limit = MathMin(MathMax(Bars - counted_bars, half), Bars - 1);
  
  if (returnBars)
   {
    buffer1[0] = limit + 1;
    
    return(0);
   } // exit if (returnBars)
  
  if (calculateValue || timeFrame == Period())
   {
    if (trend[limit] == 1)
     ClearPoint(limit, buffer2, buffer3);
    
    for (int i = limit; i >= 0; i--)
     {
      double mod = 1.0;
      
      if (i < half)
       {
        double weightTotal = 0;
        
        for (int j = half - i; j < size; j++)
         weightTotal += weights[j];
        
        if (weightTotal != 0)
         mod = 1.0 / weightTotal;
       } // exit if (i < half)
      
      double sum = mod * weights[half] * (1 + sdvig) * iMA(NULL, 0, 1, 0, MODE_SMA, Price, i);//    ***  10.04.16   !!! ***
      
      for (j = 1; j <= half; j++)
       {
        if (j <= i)
         sum += mod * weights[half + j] * iMA(NULL, 0, 1, 0, MODE_SMA, Price, i - j);
         sum += mod * weights[half - j] * iMA(NULL, 0, 1, 0, MODE_SMA, Price, i + j);
       } // exit for (j = 1; j <= half; j++)
      
      buffer1[i] = sum;
      buffer2[i] = EMPTY_VALUE;
      buffer3[i] = EMPTY_VALUE;
      
      //-----
      if (buffer1[i] > buffer1[i + 1])
       trend[i] = 1;
      
      if (buffer1[i] < buffer1[i + 1])
       trend[i] = -1;
      
      if (trend[i] == 1)
       PlotPoint(i, buffer2, buffer3, buffer1);
     } // exit for (int i = limit; i >= 0; i--)
    
    return(0);
   } // exit if (calculateValue || timeFrame == Period())
  
  limit = MathMax(limit, MathMin(Bars - 1, iCustom(NULL, timeFrame, indicatorFileName, "returnBars", 0, 0) * timeFrame / Period()));
  
  if (trend[limit] == 1)
   ClearPoint(limit, buffer2, buffer3);
  
  for (i = limit; i >= 0; i--)
   {
    int y = iBarShift(NULL, timeFrame, Time[i]);
    
    trend  [i] = iCustom(NULL, timeFrame, indicatorFileName, "calculateValue", Price, FilterSize, 3, y);
    buffer1[i] = iCustom(NULL, timeFrame, indicatorFileName, "calculateValue", Price, FilterSize, 0, y);
    buffer2[i] = EMPTY_VALUE;
    buffer3[i] = EMPTY_VALUE;
    
    if (!Interpolate || y == iBarShift(NULL, timeFrame, Time[i - 1]))
     continue;
    
    datetime time = iTime(NULL, timeFrame, y);
    
    for (int n = 1; i + n < Bars && Time[i + n] >= time; n++)
     continue;	
    
    for (int k = 1; k < n; k++)
     buffer1[i + k] = buffer1[i] + (buffer1[i + n] - buffer1[i]) * k / n;
   } // exit for (i = limit; i >= 0; i--)
  
  for (i = limit; i >= 0; i--)
   if (trend[i] == 1)
    PlotPoint(i, buffer2, buffer3, buffer1);
  
  //-------------------------
  return(0);
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ClearPoint(int i, double &first[], double &second[])
 {
  if (second[i    ] != EMPTY_VALUE &&
      second[i + 1] != EMPTY_VALUE)
   second[i + 1] = EMPTY_VALUE;
  else
   if (first[i    ] != EMPTY_VALUE &&
       first[i + 1] != EMPTY_VALUE &&
       first[i + 2] == EMPTY_VALUE)
    first[i + 1] = EMPTY_VALUE;
  
  //-------------------------
  return;
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void PlotPoint(int i, double &first[], double &second[], double &from[])
 {
  if (first[i + 1] == EMPTY_VALUE)
   {
    if (first[i + 2] == EMPTY_VALUE)
     {
      first [i   ] = from[i];
      first [i +1] = from[i + 1];
      second[i   ] = EMPTY_VALUE;
     } // exit if (first[i + 2] == EMPTY_VALUE)
    else
     {
      second[i    ] = from[i];
      second[i + 1] = from[i + 1];
      first [i    ] = EMPTY_VALUE;
     } // exit if (first[i + 2] != EMPTY_VALUE)
   } // exit if (first[i + 1] == EMPTY_VALUE)
  else
   {
    first [i] = from[i];
    second[i] = EMPTY_VALUE;
   } // exit if (first[i + 1] != EMPTY_VALUE)
  
  //-------------------------
  return;
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int stringToTimeFrame(string tfs)
 {
  tfs = stringUpperCase(tfs);
  
  for (int i = ArraySize(iTfTable) - 1; i >= 0; i--)
   if (tfs == sTfTable[i] ||
       tfs == "" + iTfTable[i])
    return(MathMax(iTfTable[i], Period()));
  
  //-------------------------
  return(Period());
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
string stringUpperCase(string str)
 {
  string s = str;
  
  for (int length = StringLen(str) - 1; length >= 0; length--)
   {
    int char1 = StringGetChar(s, length);
    
    if ((char1 > 96   &&
         char1 < 123) ||
        (char1 > 223  &&
         char1 < 256))
     s = StringSetChar(s, length, char1 - 32);
    else
     if (char1 > -33 &&
         char1 < 0)
      s = StringSetChar(s, length, char1 + 224);
   } // exit for (int length = StringLen(str) - 1; length >= 0; length--)
  
  //-------------------------
  return(s);
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
